<?php

/**
 * Observium
 *
 *   This file is part of Observium.
 *
 * @package        observium
 * @subpackage     poller
 * @copyright  (C) Adam Armstrong
 *
 */

$table_defs['NS-ROOT-MIB']['nsSslStatsGroup'] = [
  'table'     => 'nsSslStatsGroup',
  'mib'       => 'NS-ROOT-MIB',
  'mib_dir'   => 'citrix',
  'file'      => 'netscaler-SslStats.rrd',
  'graphs'    => ['nsSslTransactions', 'nsSslHandshakes', 'nsSslSessions'],
  'ds_rename' => ['sslBeTot'    => 'Be', 'sslTot' => '', 'ssl' => '', 'Session' => 'Sess', 'Multiplex' => 'Mplx', 'Attempt' => 'Att',
                  'Success'     => 'Succ', 'Authentications' => 'Auths', 'Authorizations' => 'Auths', 'Ciphers' => 'Ciphs',
                  'ReNegotiate' => 'ReNeg', 'Exchanges' => 'Exch'],
  'oids'      => [
    'sslCardStatus'                          => ['ds_type' => 'GAUGE'],
    'sslEngineStatus'                        => ['ds_type' => 'GAUGE'],
    'sslSessionsPerSec'                      => ['ds_type' => 'GAUGE'],
    'sslTotTransactions'                     => [],
    'sslTotSSLv2Transactions'                => [],
    'sslTotSSLv3Transactions'                => [],
    'sslTotTLSv1Transactions'                => [],
    'sslTotSessions'                         => [],
    'sslTotSSLv2Sessions'                    => [],
    'sslTotSSLv3Sessions'                    => [],
    'sslTotTLSv1Sessions'                    => [],
    'sslTotExpiredSessions'                  => [],
    'sslTotNewSessions'                      => [],
    'sslTotSessionHits'                      => [],
    'sslTotSessionMiss'                      => [],
    'sslTotRenegSessions'                    => [],
    'sslTotSSLv3RenegSessions'               => [],
    'sslTotTLSv1RenegSessions'               => [],
    'sslTotSSLv2Handshakes'                  => [],
    'sslTotSSLv3Handshakes'                  => [],
    'sslTotTLSv1Handshakes'                  => [],
    'sslTotSSLv2ClientAuthentications'       => [],
    'sslTotSSLv3ClientAuthentications'       => [],
    'sslTotTLSv1ClientAuthentications'       => [],
    'sslTotRSA512keyExchanges'               => [],
    'sslTotRSA1024keyExchanges'              => [],
    'sslTotRSA2048keyExchanges'              => [],
    'sslTotDH512keyExchanges'                => [],
    'sslTotDH1024keyExchanges'               => [],
    'sslTotDH2048keyExchanges'               => [],
    'sslTotRSAAuthorizations'                => [],
    'sslTotDHAuthorizations'                 => [],
    'sslTotDSSAuthorizations'                => [],
    'sslTotNULLAuthorizations'               => [],
    'sslTot40BitRC4Ciphers'                  => [],
    'sslTot56BitRC4Ciphers'                  => [],
    'sslTot64BitRC4Ciphers'                  => [],
    'sslTot128BitRC4Ciphers'                 => [],
    'sslTot40BitDESCiphers'                  => [],
    'sslTot56BitDESCiphers'                  => [],
    'sslTot168Bit3DESCiphers'                => [],
    'sslTot40BitRC2Ciphers'                  => [],
    'sslTot56BitRC2Ciphers'                  => [],
    'sslTot128BitRC2Ciphers'                 => [],
    'sslTot128BitIDEACiphers'                => [],
    'sslTotNULLCiphers'                      => [],
    'sslTotMD5Mac'                           => [],
    'sslTotSHAMac'                           => [],
    'sslTotOffloadBulkDES'                   => [],
    'sslTotOffloadRSAKeyExchanges'           => [],
    'sslTotOffloadDHKeyExchanges'            => [],
    'sslTotOffloadSignRSA'                   => [],
    'sslBeTotSessions'                       => [],
    'sslBeTotSSLv3Sessions'                  => [],
    'sslBeTotTLSv1Sessions'                  => [],
    'sslBeExpiredSessions'                   => [],
    'sslBeTotSessionMultiplexAttempts'       => [],
    'sslBeTotSessionMultiplexAttemptSuccess' => [],
    'sslBeTotSessionMultiplexAttemptFails'   => [],
    'sslBeMaxMultiplexedSessions'            => ['ds_type' => 'GAUGE'],
    'sslBeTotSSLv3Handshakes'                => [],
    'sslBeTotTLSv1Handshakes'                => [],
    'sslBeTotSSLv3ClientAuthentications'     => [],
    'sslBeTotTLSv1ClientAuthentications'     => [],
    'sslBeTotRSA512keyExchanges'             => [],
    'sslBeTotRSA1024keyExchanges'            => [],
    'sslBeTotRSA2048keyExchanges'            => [],
    'sslBeTotDH512keyExchanges'              => [],
    'sslBeTotDH1024keyExchanges'             => [],
    'sslBeTotDH2048keyExchanges'             => [],
    'sslBeTotRSAAuthorizations'              => [],
    'sslBeTotDHAuthorizations'               => [],
    'sslBeTotDSSAuthorizations'              => [],
    'sslBeTotNULLAuthorizations'             => [],
    'sslBeTot40BitRC4Ciphers'                => [],
    'sslBeTot56BitRC4Ciphers'                => [],
    'sslBeTot64BitRC4Ciphers'                => [],
    'sslBeTot128BitRC4Ciphers'               => [],
    'sslBeTot40BitDESCiphers'                => [],
    'sslBeTot56BitDESCiphers'                => [],
    'sslBeTot168Bit3DESCiphers'              => [],
    'sslBeTot40BitRC2Ciphers'                => [],
    'sslBeTot56BitRC2Ciphers'                => [],
    'sslBeTot128BitRC2Ciphers'               => [],
    'sslBeTot128BitIDEACiphers'              => [],
    'sslBeTotNULLCiphers'                    => [],
    'sslBeTotMD5Mac'                         => [],
    'sslBeTotSHAMac'                         => [],
    'sslCurSessions'                         => ['ds_type' => 'GAUGE'],
    'sslTotOffloadBulkAES'                   => [],
    'sslTotOffloadBulkRC4'                   => [],
    'sslNumCardsUP'                          => ['ds_type' => 'GAUGE'],
    'sslCards'                               => ['ds_type' => 'GAUGE'],
    'sslTotBkendSessionReNegotiate'          => [],
    'sslTotCipherAES128'                     => [],
    'sslTotBkendSslV3Renego'                 => [],
    'sslTotBkendTlSvlRenego'                 => [],
    'sslTotCipherAES256'                     => [],
    'sslTotBkendCipherAES128'                => [],
    'sslTotBkendCipherAES256'                => [],
    'sslTotHwEncBE'                          => [],
    'sslTotDec'                              => [],
    'sslTotSwEncFE'                          => [],
    'sslTotEncFE'                            => [],
    'sslTotEnc'                              => [],
    'sslTotDecHw'                            => [],
    'sslTotSwDecBE'                          => [],
    'sslTotHwDecFE'                          => [],
    'sslTotEncHw'                            => [],
    'sslTotDecSw'                            => [],
    'sslTotSwEncBE'                          => [],
    'sslTotEncSw'                            => [],
    'sslTotSwDecFE'                          => [],
    'sslTotEncBE'                            => [],
    'sslTotDecBE'                            => [],
    'sslTotHwDecBE'                          => [],
    'sslTotDecFE'                            => [],
    'sslTotHwEncFE'                          => [],
    'sslTotRSA4096keyExchanges'              => [],
    'sslCurQSize'                            => ['ds_type' => 'GAUGE'],
    'sslChipReinitCount'                     => [],
    'sslTotECDHE224keyExchanges'             => [],
    'sslTotECDHE256keyExchanges'             => [],
    'sslTotECDHE384keyExchanges'             => [],
    'sslTotECDHE521keyExchanges'             => [],
    'sslTotTransactionsRate'                 => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.333)', 'descr' => 'SSL Transactions rate per second.', 'ds_type' => 'GAUGE'],
    'sslTotSSLv2TransactionsRate'            => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.334)', 'descr' => 'SSLv2 Transactions rate per second.', 'ds_type' => 'GAUGE'],
    'sslTotSSLv3TransactionsRate'            => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.335)', 'descr' => 'SSLv3 Transactions rate per second.', 'ds_type' => 'GAUGE'],
    'sslTotTLSv1TransactionsRate'            => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.336)', 'descr' => 'TLSv1 Transactions rate per second.', 'ds_type' => 'GAUGE'],
    'sslBeTotEcdheCurve521'                  => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.337)', 'descr' => 'Number of back-end ECDHE 521 curve Key exchanges on the NetScaler appliance.'],
    'sslBeTotEcdheCurve384'                  => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.338)', 'descr' => 'Number of back-end ECDHE 384 curve Key exchanges on the NetScaler appliance.'],
    'sslBeTotEcdheCurve256'                  => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.339)', 'descr' => 'Number of back-end ECDHE 256 curve Key exchanges on the NetScaler appliance.'],
    'sslBeTotEcdheCurve224'                  => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.340)', 'descr' => 'Number of back-end ECDHE 224 curve Key exchanges on the NetScaler appliance.'],
    'sslTotTLSv11Handshakes'                 => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.341)', 'descr' => 'Number of SSL handshakes on TLSv1.1 on the NetScaler appliance.'],
    'sslTotTLSv12Handshakes'                 => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.342)', 'descr' => 'Number of SSL handshakes on TLSv1.2 on the NetScaler appliance.'],
    'sslTotTLSv11Transactions'               => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.343)', 'descr' => 'Number of TLSv1.1 transactions on the NetScaler appliance.'],
    'sslTotTLSv12Transactions'               => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.344)', 'descr' => 'Number of TLSv1.2 transactions on the NetScaler appliance.'],
    'sslTotTLSv11Sessions'                   => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.345)', 'descr' => 'Number of TLSv1.1 sessions on the NetScaler appliance.'],
    'sslTotTLSv12Sessions'                   => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.346)', 'descr' => 'Number of TLSv1.2 sessions on the NetScaler appliance.'],
    'sslTotTLSv11RenegSessions'              => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.347)', 'descr' => 'Number of SSL session renegotiations done on TLSv1.1.'],
    'sslTotTLSv12RenegSessions'              => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.348)', 'descr' => 'Number of SSL session renegotiations done on TLSv1.2.'],
    'sslTotTLSv11ClientAuthentications'      => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.349)', 'descr' => 'Number of client authentications done on TLSv1.1.'],
    'sslTotTLSv12ClientAuthentications'      => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.350)', 'descr' => 'Number of client authentications done on TLSv1.2.'],
    'sslTotTLSv11TransactionRate'            => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.351)', 'descr' => 'TLSv1.1 Transactions rate per second.', 'ds_type' => 'GAUGE'],
    'sslTotTLSv12TransactionRate'            => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.352)', 'descr' => 'TLSv1.2 Transactions rate per second.', 'ds_type' => 'GAUGE'],
    'sslTot128BitAESGCMCiphers'              => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.353)', 'descr' => 'Number of AEC-GCM 128-bit cipher encryptions on the NetScaler appliance.'],
    'sslTot256BitAESGCMCiphers'              => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.354)', 'descr' => 'Number of AEC-GCM 256-bit cipher encryptions on the NetScaler appliance.'],
    'sslTotOffloadBulkAESGCM128'             => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.355)', 'descr' => 'Number of AES-GCM 128-bit encryptions offloaded to the cryptography card.'],
    'sslTotOffloadBulkAESGCM256'             => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.356)', 'descr' => 'Number of AES-GCM 256-bit encryptions offloaded to the cryptography card.'],
    'sslBeTotTLSv11Sessions'                 => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.357)', 'descr' => 'Number of back-end TLSv1.1 sessions on the NetScaler appliance.'],
    'sslBeTotTLSv12Sessions'                 => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.358)', 'descr' => 'Number of back-end TLSv1.2 sessions on the NetScaler appliance.'],
    'sslBeTotTLSv11Handshakes'               => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.359)', 'descr' => 'Number of back-end TLSv1.1 handshakes on the NetScaler appliance.'],
    'sslBeTotTLSv12Handshakes'               => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.360)', 'descr' => 'Number of back-end TLSv1.2 handshakes on the NetScaler appliance.'],
    'sslBeTotTLSv11ClientAuthentications'    => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.361)', 'descr' => 'Number of back-end TLSv1.1 client authentications on the NetScaler appliance.'],
    'sslBeTotTLSv12ClientAuthentications'    => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.362)', 'descr' => 'Number of back-end TLSv1.2 client authentications on the NetScaler appliance.'],
    'sslTotBkendTlSv11Renego'                => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.363)', 'descr' => 'Number of back-end TLSv1.1 session renegotiations on the NetScaler appliance.'],
    'sslTotBkendTlSv12Renego'                => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.364)', 'descr' => 'Number of back-end TLSv1.2 session renegotiations on the NetScaler appliance.'],
    'sslCryptoUtilization'                   => ['numeric' => '(1.3.6.1.4.1.5951.4.1.1.47.365)', 'descr' => 'Utilization of the hardware crypto resource. Only valid values are 0-100%. Only works for platform with N3 chips A value of 4294967295 is displayed for a platform without a N3 chip', 'ds_type' => 'GAUGE'],
  ]
];

