<?php

/**
 * Observium
 *
 *   This file is part of Observium.
 *
 * @package        observium
 * @subpackage     poller
 * @copyright  (C) Adam Armstrong
 *
 */

$table_defs['NS-ROOT-MIB']['nsTcpStatsGroup'] = [
  'table'     => 'nsTcpStatsGroup',
  'mib'       => 'NS-ROOT-MIB',
  'mib_dir'   => 'citrix',
  'file'      => 'netscaler-stats-tcp.rrd',
  'ds_rename' => ["tcp" => "", "Active" => "Ac", "Passive" => "Ps", "Zombie" => "Zom"],
  'graphs'    => ['netscaler_tcp_conn', 'netscaler_tcp_bits', 'netscaler_tcp_pkts', 'netscaler_tcp_errretransmit',
                  'netscaler_tcp_errretransmitgiveup', 'netscaler_tcp_errfullretransmit', 'netscaler_tcp_errpartialretransmit',
                  'netscaler_tcp_errfastretransmissions', 'netscaler_tcp_errxretransmissions',
                  'netscaler_conn_zombie_flushed', 'netscaler_retransmission_error',
                  'netscaler_common_errors', 'netscaler_conn_zombie_halfclosed', 'netscaler_retransmit_err',
                  'netscaler_conn_client', 'netscaler_conn_zombie_halfopen', 'netscaler_rst_errors',
                  'netscaler_conn_clientserver', 'netscaler_conn_zombie_packets', 'netscaler_syn_errors',
                  'netscaler_conn_current', 'netscaler_cookie_rejected', 'netscaler_syn_stats',
                  'netscaler_conn_server', 'netscaler_data_errors', 'netscaler_conn_spare', 'netscaler_out_of_order'],

  'oids' => [
    'tcpCurServerConn'                           => ['ds_type' => 'GAUGE'],
    'tcpCurClientConn'                           => ['ds_type' => 'GAUGE'],
    'tcpActiveServerConn'                        => ['ds_type' => 'GAUGE'],
    'tcpCurClientConnClosing'                    => ['ds_type' => 'GAUGE'],
    'tcpCurServerConnEstablished'                => ['ds_type' => 'GAUGE'],
    'tcpCurClientConnOpening'                    => ['ds_type' => 'GAUGE'],
    'tcpCurClientConnEstablished'                => ['ds_type' => 'GAUGE'],
    'tcpCurServerConnClosing'                    => ['ds_type' => 'GAUGE'],
    'tcpSpareConn'                               => ['ds_type' => 'GAUGE'],
    'tcpSurgeQueueLen'                           => ['ds_type' => 'GAUGE'],
    'tcpCurServerConnOpening'                    => ['ds_type' => 'GAUGE'],
    'tcpCurPhysicalServers'                      => ['ds_type' => 'GAUGE'],
    'tcpReuseHit'                                => ['ds_type' => 'GAUGE'],
    'tcpTotServerConnOpened'                     => [],
    'tcpTotServerConnClosed'                     => [],
    'tcpTotClientConnOpened'                     => [],
    'tcpTotClientConnClosed'                     => [],
    'tcpTotSyn'                                  => [],
    'tcpTotSynProbe'                             => [],
    'tcpTotSvrFin'                               => [],
    'tcpTotCltFin'                               => [],
    'tcpTotRxPkts'                               => [],
    'tcpTotRxBytes'                              => [],
    'tcpTotTxPkts'                               => [],
    'tcpTotTxBytes'                              => [],
    'tcpWaitToSyn'                               => [],
    'tcpTotZombieCltConnFlushed'                 => [],
    'tcpTotZombieSvrConnFlushed'                 => [],
    'tcpTotZombieHalfOpenCltConnFlushed'         => [],
    'tcpTotZombieHalfOpenSvrConnFlushed'         => [],
    'tcpTotZombieActiveHalfCloseCltConnFlushed'  => [],
    'tcpTotZombieActiveHalfCloseSvrConnFlushed'  => [],
    'tcpTotZombiePassiveHalfCloseCltConnFlushed' => [],
    'tcpTotZombiePassiveHalfCloseSrvConnFlushed' => [],
    'tcpErrBadCheckSum'                          => [],
    'tcpErrSynInSynRcvd'                         => [],
    'tcpErrSynInEst'                             => [],
    'tcpErrSynGiveUp'                            => [],
    'tcpErrSynSentBadAck'                        => [],
    'tcpErrSynRetry'                             => [],
    'tcpErrFinRetry'                             => [],
    'tcpErrFinGiveUp'                            => [],
    'tcpErrFinDup'                               => [],
    'tcpErrRst'                                  => [],
    'tcpErrRstNonEst'                            => [],
    'tcpErrRstOutOfWindow'                       => [],
    'tcpErrRstInTimewait'                        => [],
    'tcpErrSvrRetrasmit'                         => [],
    'tcpErrCltRetrasmit'                         => [],
    'tcpErrFullRetrasmit'                        => [],
    'tcpErrPartialRetrasmit'                     => [],
    'tcpErrSvrOutOfOrder'                        => [],
    'tcpErrCltOutOfOrder'                        => [],
    'tcpErrCltHole'                              => [],
    'tcpErrSvrHole'                              => [],
    'tcpErrCookiePktSeqReject'                   => [],
    'tcpErrCookiePktSigReject'                   => [],
    'tcpErrCookiePktSeqDrop'                     => [],
    'tcpErrCookiePktMssReject'                   => [],
    'tcpErrRetransmit'                           => [],
    'tcpErrRetransmitGiveUp'                     => [],
    'pcbTotZombieCall'                           => [],
    'tcpTotSynHeld'                              => [],
    'tcpTotSynFlush'                             => [],
    'tcpTotFinWaitClosed'                        => [],
    'tcpErrAnyPortFail'                          => [],
    'tcpErrIpPortFail'                           => [],
    'tcpErrSentRst'                              => [],
    'tcpErrBadStateConn'                         => [],
    'tcpErrFastRetransmissions'                  => [],
    'tcpErrFirstRetransmissions'                 => [],
    'tcpErrSecondRetransmissions'                => [],
    'tcpErrThirdRetransmissions'                 => [],
    'tcpErrForthRetransmissions'                 => [],
    'tcpErrFifthRetransmissions'                 => [],
    'tcpErrSixthRetransmissions'                 => [],
    'tcpErrSeventhRetransmissions'               => [],
    'tcpErrDataAfterFin'                         => [],
    'tcpErrRstThreshold'                         => [],
    'tcpErrOutOfWindowPkts'                      => [],
    'tcpErrSynDroppedCongestion'                 => [],
    'tcpWaitData'                                => [],
    'tcpErrStrayPkt'                             => []
  ]
];

// EOF
