<?php

/**
 * Observium
 *
 *   This file is part of Observium.
 *
 * @package        observium
 * @subpackage     poller
 * @copyright  (C) Adam Armstrong
 *
 */

// ProxyAV devices hide their CPUs/Memory/Interfaces in here

$mib = 'BLUECOAT-SG-USAGE-MIB';

$oids = ['deviceUsagePercent'];

if (!is_array($cache_storage[$mib])) {
    foreach ($oids as $oid) {
        $cache_mempool = snmpwalk_cache_oid($device, $oid, $cache_mempool, $mib);
    }
    $cache_storage[$mib] = $cache_mempool;
} else {
    print_debug("Cached!");
    $cache_mempool = $cache_storage[$mib];
}

$mempool['perc'] = $cache_mempool[$mempool['mempool_index']]['deviceUsagePercent'];

// EOF
